\newpage

\chapter{Introduction}
Today many sectors, such as digital signal processing, scientific computing, computer graphics, and other application areas, have evolved to the point where their functionality requires performance levels that are not attainable on traditional CPU-based systems. 

Advancements of processors are largely driven by Moore’s Law, which predicts that the number of transistors per silicon area doubles every $18$ months \cite{moore1998cramming}. While Moore’s Law is expected to continue for a few years, computer architects are moving along a fundamental shift in how the large amounts of available transistors are used to increase performance. Historically, performance improvements of microprocessors came from both increasing the frequency at which the processors run, and by increasing the amount of work performed in each cycle. 

This increasing need for resource- and power-efficient computing has stimulated the emergence of compute platforms with moderate or high levels of parallelism, like GPU, SIMD, and manycore processors in a variety of application domains \cite{paranjape2010heterogeneous}. Furthermore, the ultimate technologies now allow designers to place CPU, GPU and DSP elements onto a single System on Chip (SoC). This allows smaller devices, reduces cost and saves power, moreover on-chip communication uses far less energy than off-chip connections.

%% Heterogeneous Computing

These factors have led to the use of heterogeneous computing, with specialized accelerators that complement general purpose CPU, and act as coprocessors for parallel workloads, to provide both power and performance benefits. Accelerator-based --or heterogeneous-- computing has become increasingly important in a variety of scenarios~\cite{power2013heterogeneous}, ranging from High-Performance Computing (HPC) to embedded systems. In particular, modern many-core systems are based on a considerable number of lightweight processor cores typically connected through a Network-on-Chip (NoC) \cite{bjerregaard2006survey}, providing a scalable approach to the interconnection of parallel on-chip systems. To maximize resource and power efficiency, accelerator architectures tend to rely on parallelism to improve performance, with multi/many-core accelerators being today commonplace. 

%% Programmability Issue - Solution: exploration platfomr with customizable compiler

The main issue of heterogeneous computing model is that a programmers can only choose proprietary parallel programming languages. Existing programming toolkits have either been limited to a single product family, limiting the application (and the developers skills) on a specific vendor platform. Running the application on another system means to rewrite it. These limitations make it difficult for a developer to achieve the full compute power of heterogeneous computing model and a parallel code developer must well know the accelerator structure on which their application will be running. To gain the full benefits of this integration, separate components need shared access to the data they process. Getting these diverse accelerators to work as a team is no easy task. We need a unique model that presents these features in a manner comprehensible to mainstream software developers, supported by their already existing development environments and  by future and current hardware accelerators.

In most heterogenous computing platforms the memory on the accelerator is completely separate from host memory, hence parallel software developers are forced to manage main memory within their own application programs, and all data movement between host memory and device memory must be managed by the programmer through platform specific function and libraries that explicitly move data between the separate memories. Therefore, in an accelerator-targeted region, the programmers must orchestrate the execution by allocating memory on the accelerator device, initiating data transfer, sending the code to the accelerator, passing arguments to the compute region, queuing the device code, waiting for completion, transferring results back to the host, and deallocating memory.
The concept of separate host and accelerator memories is very apparent in low-level accelerator programming languages such as CUDA or OpenCL, in which routine calls for data movement between the memories can dominate user code and a programmer cannot be unaware of memory structure. Knowing the specific accelerator structure has become an important requirement for the programmers.

An ideal heterogenous computing model should allow programmers to create applications capable of using accelerators, with data movement between the host and accelerator implicit and managed by the compiler, without explicit accelerator startup and shutdown. An application designed for this model should be compatible for a wide assortment of data-parallel and task-parallel architectures and not restricted to a specific vendor platform (e.g. CUDA). At last, a heterogenous computing model should take into account the need to reduce system power consumption, even for devices that get their power from the wall.

%% MANGO

Such motivations gave birth to the \texttt{Horizon 2020 MANGO} project, which aims at exploring deeply heterogeneous accelerators for use in high-performance computing systems running multiple applications with different Quality of Service (QoS) levels. The main goal of the project is to exploit customization to adapt computing resources to reach the desired QoS. For this purpose, it explores different but interrelated mechanisms across the architecture and system software. Along its path, the project involves different, and deeply interrelated, mechanisms at various architectural levels, from the heterogeneous computing cores, up to the memory architecture, the interconnect, the run-time resource management, power monitoring and cooling, also evaluating the implications on programming models and compilation techniques. Modern high-performance computing applications present a gap between the applications demand and the underlying architecture. 
Enabling a deeper customization of architectures to applications will eventually lead to computation efficiency, since it allows the computing platform to approximate the ideal system, featuring a fine-grained adaptation, or customization, used to tailor and/or reserve computing resources only driven by the application requirements. 
%% Many-core problem: Coherence

Finally, in such scenarios, coherent shared memory could be an important facility \cite{martin2012chip} acting as a key enabler for programmer-friendly models exposed to the software as well as for the effective adaptation of existing parallel applications. However, unlike general-purpose architectures, hardware-managed coherence poses a major challenge for accelerators, due to the cost of the coherence infrastructure as well as the possible limitations in terms of scalability and performance. Full implementation of standard coherence protocols can induce significant overheads even when there is essentially no data sharing, e.g. when handling a nonshared block eviction. In fact, in many workloads a significant fraction of blocks are private to a single processing unit requiring in principle no coherence maintenance~\cite{hardavellas2009reactive,cuesta11}. 

%% Conclusionf

While such problems have been widely investigated in the area of conventional homogeneous architectures, existing solutions do not always fit heterogeneity, moreover many-core accelerator-based systems pose special requirements and constraints, requiring further exploration of both hardware and software techniques.

\section{Methodology}
This dissertation is placed in the framework of the MANGO H2020 project, and shares its main motivations. The main goal is to define and pose a methodology for exploring novel solutions targeting heterogeneous systems. Future many-cores require exploration over new infrastructures typical of this novel paradigm (such as NoCs and sparse directories), which involves both hardware and software mechanisms in order to exploit scalability and higher efficiency, with customization has key-enablers to achieve such desirable features. 

This work leverages on a baseline heterogeneous platform, developed in the framework of the MANGO project, to evaluate novel solutions proposed in this dissertation. This system, called nu+, is an open-source NoC-based platform compliant with modern heterogeneous system trends. The platform aims to be highly modular, deeply customizable, meant to be easily extendible on both hardware and software levels, essential features for architectural exploration. This full-system enables us to better understand application-specific requirements through hardware customization, and also to evaluate the proposed solutions on a real system, running significant kernels extracted from typical workloads. 

The dissertation proposes novel solutions suitable for improving performance in heterogeneous-based accelerators. The mechanisms described in this dissertation come from an exploration phase using significative application classes, such as deep learning-based algorithms, running on our baseline platform, which helped us to underline application-specific requirements and ideal configurations. In such phase, we identified bottlenecks and possible improvements, focusing on coherence- and NoC-related aspects. Each proposed solution has been integrated on both software and hardware levels in our baseline heterogeneous platform for validating and testing them in a real system. Such approach also captures realistic results, implementation issues, and pitfalls not possible with typical simulation-based evaluation methods. 

\section{Thesis Structure}
The remainder of this thesis is organized as follows. Chapter \ref{chapt:back} presents the background on modern heterogeneous systems, NoC-based interconnection infrastructures, and an overview of cache coherence problem in many-core systems. Chapters \ref{chapt:core} and \ref{chapt:coherence} discuss the baseline platforms, methodology, and software tools used for evaluations. Chapter \ref{chapt:parallel} presents a first exploration study exploiting application-based customizations and aiming to underline promising performance enhancer in the context of heterogeneous accelerators. Chapter \ref{chapt:spm} develops a non-coherent fast scratchpad memory for GPU-like accelerators. Chapter \ref{chapt:barrier} presents a novel synchronization mechanism suitable for many-cores. Chapter \ref {chapt:regions} discusses the benefits of a coherence subsystem with non-coherent regions support for NoC-based many-cores. Finally the Conclusion chapter recapitulates the contributions and results.